import java.lang.reflect.Field;
import java.lang.NoSuchFieldException;
import java.util.Map;
import org.python.util.PythonInterpreter;
import org.python.core.PySystemState;
import org.python.core.PyType;

public class Test1522
{

    private static Field class_to_type_field = null;

    private synchronized static int getClassToTypeSize() {
        try {
            if (class_to_type_field == null) {
                class_to_type_field = PyType.class.getDeclaredField("class_to_type");
                class_to_type_field.setAccessible(true);
                System.err.println("class_to_type:" + class_to_type_field);
            }
            return ((Map)(class_to_type_field.get(null))).size();
        }
        catch (NoSuchFieldException ex) {
            throw new RuntimeException(ex);
        }
        catch (IllegalAccessException ex) {
            throw new RuntimeException(ex);
        }
    }

    private static void runScript() throws Exception
    {
        PySystemState sys = new PySystemState();
        PythonInterpreter pi = new PythonInterpreter(null, sys);
        pi.execfile("test1522.py");
        pi.cleanup();
    }

    public static void main(String[] args) throws Exception, NoSuchFieldException
    {
        System.out.println("\nbefore running script class_to_type size:" + getClassToTypeSize());
        for(int i=0; i<5;i++)
        {
            System.out.println("before running script class_to_type size:" + getClassToTypeSize());
            runScript();
            System.out.println("class_to_type size:" + getClassToTypeSize());
            System.gc();
            System.gc();
            System.gc();
            System.out.println("class_to_type size (post-gc):" + getClassToTypeSize());
        }
    }
}
